### Query Firewall ports and services
---
## Create output file
- name: Create query_firewalld file
  file:
    path: /tmp/query_firewalld_{{ inventory_hostname }}.txt
    state: touch

## Run command - list zones
- name: Run list zones command
  shell: firewall-cmd --get-active-zones
  register: query_firewalld_zones

## Command output to output file
- name: Append output to query_firewalld file
  copy:
    content: "{{ query_firewalld_zones.stdout}}"
    dest: /tmp/query_firewalld_{{ inventory_hostname }}.txt

## Run command - list services
- name: Run list-services command
  shell: firewall-cmd --list-services | {{ sed }}
  register: query_firewalld_services

## Copy output to output file
- name: Append output to query_firewalld file
  lineinfile:
    line: "{{ query_firewalld_services.stdout }}"
    dest: /tmp/query_firewalld_{{ inventory_hostname }}.txt
    insertafter: EOF

## Run command - list ports
- name: Run list-ports command
  shell: firewall-cmd --list-ports | {{ sed }}
  register: query_firewalld_ports

## Copy output to output file
- name: Append output to query_firewalld file
  lineinfile:
    line: "{{ query_firewalld_ports.stdout }}"
    dest: /tmp/query_firewalld_{{ inventory_hostname }}.txt
    insertafter: EOF

## Copy/sync file to localhost location
## the file will be located in /temp/firewall/IP/tmp/
- name: Synchronization of src on the control machine to dest on the remote hosts
    fetch:
      src=/tmp/query_firewalld_{{ inventory_hostname }}.txt
      dest=/tmp/firewall

## after you have ran this playbook run query_firewalld_cleanup.yml on your localhost. this does a basic copy to move all the files to a single Firewall folder.

## Below are notes and incomplete/failed attempts

## need to review jinja2 templates vs running the sed command
## doesnt seem to be best practice as ansible gives a warning and it doesnt sort

#- name: Format file
#  shell: {{ sed }} | {{ sort }}
#    with_items:
#      - "{{ query_firewalld_doc }}"
#    replace: query_firewalld_"{{ inventory_hostname }}".txt

#- name: Cleanup file output
#  shell: sed 's/\s\+/\n/g' /tmp/query_firewalld_{{ inventory_hostname }}".txt | sort -o query_firewalld_"{{ inventory_hostname }}".txt

## possible a more efficent way to trasfer the file back but unable to get it working correctly
## Synchronization
## src: rsync://test@"{{ target }}":/tmp/query_firewalld_{{ inventory_hostname }}.txt
